/* 
 * Copyright (C) 2004 createagaga
 * Copyright (C) 2004-2008 Petr Kozelka, PPK at czdc dot org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef AG_EMOTICON_SETUP_H
#define AG_EMOTICON_SETUP_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../client/Util.h"

class CAGEmoticon {
public:
	typedef CAGEmoticon* Ptr;
	typedef vector<Ptr> List;
	typedef List::iterator Iter;

	CAGEmoticon();
	virtual ~CAGEmoticon();
	
	bool Create(tstring& strEmoticonText, tstring& strEmoticonBmpPath);

	const tstring& GetEmoticonText();
	HBITMAP GetEmoticonBmp();
	HBITMAP GetEmoticonBmp(const COLORREF &clrBkColor);
protected:
    bool bWithAlpha;
	HBITMAP m_EmoticonBmp;
    LONG lWidth; 
    LONG lHeight; 
	tstring m_EmoticonText;
};

// CAGEmoticonSetup
class CAGEmoticonSetup {
public:
	CAGEmoticonSetup();
	virtual ~CAGEmoticonSetup();

	bool Create(const string& emoticonfile);

    // Variables
	GETSET(bool, UseEmoticons, UseEmoticons);

    // Emoticon list
	CAGEmoticon::List EmoticonsList;
};

#endif // AG_EMOTICON_SETUP_H
